1 REMark $$i
2 REMark $$asmb=flp1_qlib_ext,0,12
10 REMark Quill simulator - how far can I take it?
11 Q_CURSON#1
12 trapping_on
15 REPeat control
20  init
22  IF Q_ERR<>0:show_err:NEXT control
25  PRINT \"Creating movement data":create_movement_data
27  IF Q_ERR<>0:show_err:NEXT control
30  OPEN_NEW#5,file$&"_BAS"
35  IF Q_ERR<>0:show_err:NEXT control
40  PRINT \"Creating Event Table":create_event_table
45  IF Q_ERR<>0:show_err:NEXT control
50  PRINT "Creating Status Table":create_status_table
55  IF Q_ERR<>0:show_err:NEXT control
60  PRINT "Creating Object Word":create_object_word
65  IF Q_ERR<>0:show_err:NEXT control
70  PRINT "Creating Messages":create_messages
75  IF Q_ERR<>0:show_err:NEXT control
80  PRINT "Creating Start Locations":create_start_locations
85  IF Q_ERR<>0:show_err:NEXT control
90  PRINT "Creating Vocabulary":create_vocab
95  PRINT "Creating variables":create_variables
97  IF Q_ERR<>0:show_err:NEXT control
100 CLOSE#5:PRINT \\\"Finished! - PRESS A KEY":PAUSE:STOP
150 END REPeat control
1000 DEFine FuNction Q_Err$
1010 REMark demo_qerr
1020   LOCal e
1030   e=Q_ERR
1040   SELect ON e
1050     =0  : RETurn ""
1060     =-1 : RETurn "not complete"
1070     =-2 : RETurn "invalid job"
1080     =-3 : RETurn "out of memory"
1090     =-4 : RETurn "out of range"
1100     =-5 : RETurn "buffer overflow"
1110     =-6 : RETurn "channel not open"
1120     =-7 : RETurn "not found"
1130     =-8 : RETurn "already exists"
1140     =-9 : RETurn "in use"
1150     =-10: RETurn "end of file"
1160     =-11: RETurn "drive full"
1170     =-12: RETurn "bad name"
1180     =-13: RETurn "transmission error"
1190     =-14: RETurn "format failed"
1200     =-15: RETurn "bad parameter"
1210     =-16: RETurn "file error"
1220     =-17: RETurn "error in expression"
1230     =-18: RETurn "arithmetic overflow"
1240     =-19: RETurn "not implemented"
1250     =-20: RETurn "read only"
1260     =-21: RETurn "bad line"
1270     =REMAINDER : RETurn "error "&e
1280   END SELect
1290 END DEFine
1300 DEFine PROCedure trapping_on
1310 Q_ERR_ON "OPEN_IN","OPEN_NEW","LBYTES","PRINT","CLOSE","INPUT"
1350 END DEFine
1400 DEFine PROCedure show_err
1410  PRINT Q_Err$\"Press a key..."
1420  REPeat kloop:IF INKEY$(#1)<>"":EXIT kloop
1425  END REPeat kloop
1430 END DEFine
2000 DEFine PROCedure init
2005  MODE 4:WINDOW 512,256,0,0:PAPER 0:CLS:WINDOW 455,225,35,10:INK 4:UNDER 1:AT 0,10:PRINT "ADVENTURE TRANSFER UTILITY  v1.2   A. Pemberton 1989-98"\\:UNDER 0
2010  q=0:e=0:restart=0
2020  load_file
2025  IF Q_ERR<>0:RETurn
2030  paper_=PEEK(addr+1):ink_=PEEK(addr+2)
2040  obj_max=PEEK(addr+6)
2050  items=PEEK(addr+7)
2060  length_of_file=l_word(13)
2070  bwidth=PEEK(addr+4)
2080  bcol=PEEK(addr+5)
2090  no_objects=PEEK(addr+7)
2100  no_locations=PEEK(addr+8)
2110  no_messages=PEEK(addr+9)
2120  no_sysmess=PEEK(addr+10)
2130  total_messages=no_objects+no_locations+no_messages+no_sysmess
2140 END DEFine
2150 DEFine PROCedure load_file
2160  INPUT "Name of QUILL data file for transfer : ";file$
2165  Q_CURSON#1
2170  get_size
2175  IF Q_ERR<>0:RETurn
2180  addr=RESPR(length_of_file)
2185  IF Q_ERR<>0:show_err:STOP
2190  LBYTES file$,addr
2195  IF Q_ERR<>0:RETurn
2200 END DEFine
2210 DEFine PROCedure get_size
2220  OPEN_IN#5,file$
2225  IF Q_ERR<>0:RETurn
2230  FOR r=1 TO 52:x$=INKEY$(#5)
2240  DIM xl(4)
2250  FOR r=1 TO 4:xl(r)=CODE(INKEY$(#5))
2260  CLOSE#5
2270  length_of_file=65536*xl(2)+256*xl(3)+xl(4)
2290 END DEFine
2300 DEFine FuNction l_word (n)
2310  RETurn PEEK_L(addr+n*4)
2320 END DEFine
2330 DEFine FuNction obj_addr (n)
2340  RETurn PEEK_L(l_word(5)+4*n+addr)
2350 END DEFine
2360 DEFine FuNction mess_addr (n)
2370  RETurn PEEK_L(l_word(7)+addr+4*n)
2380 END DEFine
2390 DEFine FuNction loc_addr (n)
2400  RETurn PEEK_L(l_word(6)+addr+4*n)
2410 END DEFine
2420 DEFine FuNction sys_addr (n)
2430  RETurn PEEK_L(l_word(8)+addr+4*n)
2440 END DEFine
2450 DEFine FuNction start_loc (n)
2460  RETurn PEEK(l_word(11)+n+addr)
2470 END DEFine
2480 DEFine FuNction obj_word (n)
2490  RETurn PEEK(l_word(12)+n+addr)
2500 END DEFine
2510 DEFine FuNction cond$ (n)
2520  x=n+addr:x$="":count=0
2530  REPeat loop
2540   a=PEEK(x)
2550   x$=x$&CHR$(a)
2560   IF a=255:count=count+1:IF count=2:EXIT loop
2570   x=x+1
2580  END REPeat loop
2590  RETurn x$
2600 END DEFine
2610 DEFine FuNction event_addr (n)
2620  RETurn PEEK_L(l_word(3)+6*n+addr+2)
2630 END DEFine
2640 DEFine FuNction event (n)
2650  RETurn PEEK_W(l_word(3)+6*n+addr)
2660 END DEFine
2670 DEFine FuNction ew1 (n)
2680  RETurn PEEK(l_word(3)+6*n+addr)
2690 END DEFine
2700 DEFine FuNction ew2 (n)
2710  RETurn PEEK(l_word(3)+6*n+addr+1)
2720 END DEFine
2730 DEFine FuNction status_addr (n)
2740  RETurn PEEK_L(l_word(4)+6*n+addr+2)
2750 END DEFine
2760 DEFine FuNction status (n)
2770  RETurn PEEK_W(l_word(4)+6*n+addr)
2780 END DEFine
2790 DEFine FuNction event (n)
2800  RETurn PEEK_W(l_word(4)+6*n+addr)
2810 END DEFine
2820 DEFine FuNction object_word (n)
2830 LOCal r,temp,temp2
2840  temp2=0
2850  FOR r=0 TO items
2860   temp=obj_word (r):IF temp=n:temp2=r:EXIT r
2870  END FOR r
2880  RETurn temp2
2890 END DEFine
2900 DEFine FuNction get_word(n$)
2910 LOCal w,gloop,v$,v
2920 RESTORE 32767:w=0
2930 REPeat gloop
2940  READ v$,v
2950  IF v=255:EXIT gloop
2960  IF v$==n$:w=v:EXIT gloop
2970 END REPeat gloop
2980 RETurn w
2990 END DEFine
3000 DEFine PROCedure create_event_table
3010  event_pointer=-1:exit_=0
3020  PRINT#5;"20000 DEFine PROCedure event_table"\"20002 REPeat loop";
3030  REPeat event_loop
3040   event_pointer=event_pointer+1
3050   word1=ew1 (event_pointer):word2=ew2 (event_pointer)
3060  IF word1=0 AND word2=0:EXIT event_loop
3070   PRINT#5\\20004+event_pointer;"  IF c(";word1;",";word2;"):";
3080   check_entry event_pointer,1
3090  END REPeat event_loop
3100  PRINT#5\\20006+event_pointer;" EXIT loop"\20007+event_pointer;" END REPeat loop"\20008+event_pointer;" BEEP"\20010+event_pointer;" END DEFine"
3110 END DEFine event_table
3120 :
3130 DEFine PROCedure check_entry (n,type)
3140 LOCal x,y
3150  IF type=1:c$=cond$(event_addr(n)):ELSE c$=cond$(status_addr(n))
3160  cp=0:count=-1
3170  REPeat check_loop
3180   cp=cp+1
3190   count=count+1
3200   condition=CODE(c$(cp))
3210   IF condition=255:PRINT#5;":c_s:";:EXIT check_loop
3220   IF count=0:PRINT#5;" IF ";:ELSE PRINT#5;" AND ";
3230   cp=cp+1:x=CODE(c$(cp))
3240   SELect ON condition
3250    =0:REMark     AT     n
3260       PRINT#5;"at_ (";x;")";
3270    =1:REMark     NOTAT  n
3280       PRINT#5;"notat (";x;")";
3290    =2:REMark     ATGT   n
3300       PRINT#5;"atgt (";x;")";
3310    =3:REMark     ATLT   n
3320       PRINT#5;"atlt (";x;")";
3330    =4:REMark     PRESENT n
3340       PRINT#5;"present (";x;")";
3350    =5:REMark absent (n)
3360       PRINT#5;"absent (";x;")";
3370    =6:REMark worn (n)
3380       PRINT#5;"worn (";x;")";
3390    =7:REMark notworn (n)
3400       PRINT#5;"notworn (";x;")";
3410    =8:REMark carried (n)
3420       PRINT#5;"carried (";x;")";
3430    =9:REMark notcarr (n)
3440       PRINT#5;"notcarr (";x;")";
3450    =10:REMark chance (n)
3460        PRINT#5;"chance (";x;")";
3470    =11:REMark zero (n)
3480        PRINT#5;"zero (";x;")";
3490    =12:REMark notzero (n)
3500        PRINT#5;"notzero (";x;")";
3510    =13:REMark eq (x,y)
3520        cp=cp+1:y=CODE(c$(cp))
3530        PRINT#5;"eq (";x;",";y;")";
3540    =14:REMark gt (x,y)
3550        cp=cp+1:y=CODE(c$(cp))
3560        PRINT#5;"gt (";x;",";y;")";
3570    =15:REMark lt (x,y)
3580        cp=cp+1:y=CODE(c$(cp))
3590        PRINT#5;"lt (";x;",";y;")";
3600    =REMAINDER :PRINT "error in conditions"
3610   END SELect
3620  END REPeat check_loop
3630  action$=c$(cp+1 TO LEN(c$))
3640  do_actions (action$)
3650 END DEFine check_entry
3660 :
3670 DEFine PROCedure do_actions (x$)
3680  a$=x$:ex$=": EXIT loop":ex2$=": IF NOT cont: EXIT loop: ELSE "
3690  ap=0
3700  REPeat action_loop
3710   exit_=0
3720   ap=ap+1
3730   action=CODE(a$(ap))
3740   IF action=255:EXIT action_loop
3750   PRINT#5;": ";
3760   SELect ON action
3770    =0:PRINT#5;"inven";ex$;
3780    =1:PRINT#5;"desc";ex$;
3790    =2:PRINT#5;"quit_: IF q=0: EXIT loop: ELSE ";
3800    =3:PRINT#5;"end_: IF e=1: STOP: ELSE restart=1: EXIT loop";
3810    =4:PRINT#5;"EXIT loop";
3820    =5:PRINT#5;"ok: EXIT loop";
3830    =6:PRINT#5;"anykey";
3840    =7:PRINT#5;"save_";
3850    =8:PRINT#5;"load_";
3860    =9:PRINT#5;"turns";
3870    =10:PRINT#5;"score";
3880    =11:PRINT#5;"CLS";
3890    =12:PRINT#5;"dropall";
3900    =13:PRINT#5;"autog";ex2$;
3910    =14:PRINT#5;"autod";ex2$;
3920    =15:PRINT#5;"autow";ex2$;
3930    =16:PRINT#5;"autor";ex2$;
3940    =17:ap=ap+1:x=CODE(a$(ap))
3950        PRINT#5;"PAUSE ";x;
3960    =18:ap=ap+1:x=CODE(a$(ap))
3970        PRINT#5;"paper_=";x;
3980    =19:ap=ap+1:x=CODE(a$(ap))
3990        PRINT#5;"ink_=";x;
4000    =20:ap=ap+1:x=CODE(a$(ap))
4010        PRINT#5;"border_=";x;
4020    =21:ap=ap+1:x=CODE(a$(ap))
4030        PRINT#5;"goto_ (";x;")";
4040    =22:ap=ap+1:x=CODE(a$(ap))
4050        PRINT#5;"message (";x;"):PRINT";
4060    =23:ap=ap+1:x=CODE(a$(ap))
4070        PRINT#5;"remove (";x;")";ex2$;
4080    =24:ap=ap+1:x=CODE(a$(ap))
4090        PRINT#5;"get_ (";x;")";ex2$;
4100    =25:ap=ap+1:x=CODE(a$(ap))
4110        PRINT#5;"drop (";x;")";ex2$;
4120    =26:ap=ap+1:x=CODE(a$(ap))
4130        PRINT#5;"wear (";x;")";ex2$;
4140    =27:ap=ap+1:x=CODE(a$(ap))
4150        PRINT#5;"destroy (";x;")";
4160    =28:ap=ap+1:x=CODE(a$(ap))
4170        PRINT#5;"create (";x;")";
4180    =29:ap=ap+1:x=CODE(a$(ap))
4190        ap=ap+1:y=CODE(a$(ap))
4200        PRINT#5;"swap ";x;",";y;
4210    =30:ap=ap+1:x=CODE(a$(ap))
4220        ap=ap+1:y=CODE(a$(ap))
4230        PRINT#5;"place ";x;",";y;
4240    =31:ap=ap+1:x=CODE(a$(ap))
4250        PRINT#5;"set (";x;")";
4260    =32:ap=ap+1:x=CODE(a$(ap))
4270        PRINT#5;"clear_ (";x;")";
4280    =33:ap=ap+1:x=CODE(a$(ap))
4290        ap=ap+1:y=CODE(a$(ap))
4300        PRINT#5;"plus ";x;",";y;
4310    =34:ap=ap+1:x=CODE(a$(ap))
4320        ap=ap+1:y=CODE(a$(ap))
4330        PRINT#5;"minus ";x;",";y;
4340    =35:ap=ap+1:x=CODE(a$(ap))
4350        ap=ap+1:y=CODE(a$(ap))
4360        PRINT#5;"let_ ";x;",";y;
4370    =36:ap=ap+1:x=CODE(a$(ap))
4380        ap=ap+1:y=CODE(a$(ap))
4390        PRINT#5;"BEEP ";x;"/100,";y;"/2-60";
4400    =37:PRINT#5;"ramsave";
4410    =38:PRINT#5;"ramload";
4420    =39:ap=ap+1:x=CODE(a$(ap))
4430        PRINT#5;"sysmess (";x;")";
4440    =REMAINDER :PRINT "mistake in actions"
4450   END SELect
4460  END REPeat action_loop
4470 END DEFine
4480 DEFine PROCedure create_status_table
4490  status_pointer=-1
4500  PRINT#5;"22000 DEFine PROCedure status_table"\"22002 REPeat loop";
4510  REPeat status_loop
4520   status_pointer=status_pointer+1
4530   PRINT#5\\22005+status_pointer;"  ";
4540   check_entry status_pointer,2
4550   IF status (status_pointer)=0:EXIT status_loop
4560  END REPeat status_loop
4570  PRINT#5\\22006+status_pointer;" EXIT loop"\22007+status_pointer;" END REPeat loop"\22008+status_pointer;" BEEP"\22010+status_pointer;" END DEFine"
4580 END DEFine
4590 DEFine PROCedure create_vocab
4600 v_addr=l_word(10)+addr:v_line=30000
4610 REPeat vloop
4620  v_addr=v_addr:v$=""
4630  FOR r=0 TO 3:v$=v$&CHR$(255-PEEK(v_addr+r))
4640  v=PEEK(v_addr+4)
4650  PRINT#5,v_line;"  DATA '";v$;"',";v
4660  v_addr=v_addr+5:v_line=v_line+1:IF v=255:EXIT vloop
4670 END REPeat vloop
4680 END DEFine
4690 DEFine PROCedure create_object_word
4700  PRINT#5,"24000 DEFine FuNction obj_word (num)"
4710  PRINT#5,"24010  dummy=num:obw=255"\"24020  SELect ON dummy"
4720  FOR r=0 TO items-1
4730   IF obj_word(r)<>255:PRINT#5;24030+r;"   =";r;":obw=";obj_word(r)
4740  END FOR r
4750  PRINT#5;"24470  END SELect"
4760  PRINT#5,"24480  RETurn obw"\"24490 END DEFine"
4770 END DEFine create_object_word
4780 DEFine PROCedure create_mess (z)
4790  LOCal xy
4800  x$="":xy=z:xy=xy+addr
4810 PRINT#5;'PRINT"';
4820  REPeat loop
4830   a=255-PEEK(xy)
4840   IF a=0:PRINT#5;'";':EXIT loop
4850   SELect ON a
4860    =32,33,35 TO 122:PRINT#5;CHR$(a);
4870    =34:PRINT#5;CHR$(126);
4880    =254:PRINT#5;'"\"';
4890    =16 TO 23:PRINT#5;'";:mink_=';a-16;':INK mink_:PRINT;"';
4900    =24:PRINT#5;'";:STRIP mink_:INK paper_:PRINT;"';
4910    =25:PRINT#5;'";:PAPER paper_:INK ink_:STRIP paper_:PRINT;"';
4920   END SELect
4930   xy=xy+1
4940  END REPeat loop
4950 PAPER paper_:INK ink_:STRIP paper_
4960 END DEFine
4970 DEFine PROCedure create_messages
4980  PRINT#5,"25000 DEFine PROCedure print_text (num)"
4990  PRINT#5,"25010  dummy=num"
5000  PRINT#5,"25020  SELect ON dummy"
5010  FOR r=0 TO total_messages-1
5020   PRINT#5,25100+r;"   =";r;":";:create_mess(obj_addr(r))
5030  END FOR r
5040  PRINT#5,"25980  END SELect"\"25990 END DEFine"
5050 END DEFine
5060 DEFine PROCedure create_movement_data
5070  OPEN_NEW#6,file$&"_DATA"
5080  start=PEEK_L(l_word(9)+addr):length=l_word(10)-start
5090  FOR r=0 TO no_locations-1
5100   temp=PEEK_L(l_word(9)+r*4+addr)-start+no_locations*2
5110   PRINT#6;CHR$(temp DIV 256);CHR$(temp MOD 256);
5120  END FOR r
5130  FOR r=start+addr TO start+addr+length:PRINT#6;CHR$(PEEK(r));
5140  CLOSE#6
5145  size=no_locations*2+length+1
5147  PRINT "Length of file : ";file$&"_DATA";" = ";size;" bytes."
5150 END DEFine
5160 DEFine PROCedure create_start_locations
5170  PRINT#5,"27000 REMark Object Start Location DATA"\"27010 DATA ";
5180  FOR r=0 TO items-2:PRINT#5;start_loc(r);",";
5190  PRINT#5;start_loc(items-1)
5200 END DEFine
5210 DEFine PROCedure create_variables
5220  PRINT#5;"32000 DEFine PROCedure set_up_variables"\"32010  paper_=";paper_
5230  PRINT#5;"32020  ink_=";ink_\"32030  bwidth=";bwidth\"32040  bcol=";bcol
5240  PRINT#5;"32050  yes$=CHR$(";255-PEEK(addr+sys_addr(30));")"
5250  PRINT#5;"32060  no$=CHR$(";255-PEEK(addr+sys_addr(31));")"
5260  PRINT#5,"32070  items=";items
5270  PRINT#5,"32080  no_messages=";no_messages
5280  PRINT#5,"32090  no_locations=";no_locations
5290  PRINT#5,"32100  no_sysmess=";no_sysmess
5300  PRINT#5,"32110  obj_max=";obj_max
5310  PRINT#5;"32200 END DEFine"
5320 END DEFine
